LaunchInstanceDetails¶
- class oci.core.models.LaunchInstanceDetails(**kwargs)¶
Bases:
objectInstance launch details. Use the sourceDetails parameter to specify whether a boot volume or an image should be used to launch a new instance.
Methods:
__init__(**kwargs)Initializes a new LaunchInstanceDetails object with values from keyword arguments.
Attributes:
Gets the agent_config of this LaunchInstanceDetails.
Gets the availability_config of this LaunchInstanceDetails.
[Required] Gets the availability_domain of this LaunchInstanceDetails.
Gets the capacity_reservation_id of this LaunchInstanceDetails.
Gets the cluster_placement_group_id of this LaunchInstanceDetails.
[Required] Gets the compartment_id of this LaunchInstanceDetails.
Gets the compute_cluster_id of this LaunchInstanceDetails.
Gets the create_vnic_details of this LaunchInstanceDetails.
Gets the dedicated_vm_host_id of this LaunchInstanceDetails.
Gets the defined_tags of this LaunchInstanceDetails.
Gets the display_name of this LaunchInstanceDetails.
Gets the extended_metadata of this LaunchInstanceDetails.
Gets the fault_domain of this LaunchInstanceDetails.
Gets the freeform_tags of this LaunchInstanceDetails.
Gets the hostname_label of this LaunchInstanceDetails.
Gets the image_id of this LaunchInstanceDetails.
Gets the instance_configuration_id of this LaunchInstanceDetails.
Gets the instance_options of this LaunchInstanceDetails.
Gets the ipxe_script of this LaunchInstanceDetails.
Gets the is_ai_enterprise_enabled of this LaunchInstanceDetails.
Gets the is_pv_encryption_in_transit_enabled of this LaunchInstanceDetails.
Gets the launch_options of this LaunchInstanceDetails.
Gets the launch_volume_attachments of this LaunchInstanceDetails.
Gets the licensing_configs of this LaunchInstanceDetails.
Gets the metadata of this LaunchInstanceDetails.
Gets the placement_constraint_details of this LaunchInstanceDetails.
Gets the platform_config of this LaunchInstanceDetails.
Gets the preemptible_instance_config of this LaunchInstanceDetails.
Gets the security_attributes of this LaunchInstanceDetails.
Gets the shape of this LaunchInstanceDetails.
Gets the shape_config of this LaunchInstanceDetails.
Gets the source_details of this LaunchInstanceDetails.
Gets the subnet_id of this LaunchInstanceDetails.
- __init__(**kwargs)¶
Initializes a new LaunchInstanceDetails object with values from keyword arguments. The following keyword arguments are supported (corresponding to the getters/setters of this class):
- Parameters
availability_domain (str) – The value to assign to the availability_domain property of this LaunchInstanceDetails.
capacity_reservation_id (str) – The value to assign to the capacity_reservation_id property of this LaunchInstanceDetails.
compartment_id (str) – The value to assign to the compartment_id property of this LaunchInstanceDetails.
create_vnic_details (oci.core.models.CreateVnicDetails) – The value to assign to the create_vnic_details property of this LaunchInstanceDetails.
dedicated_vm_host_id (str) – The value to assign to the dedicated_vm_host_id property of this LaunchInstanceDetails.
defined_tags (dict(str, dict(str, object))) – The value to assign to the defined_tags property of this LaunchInstanceDetails.
security_attributes (dict(str, dict(str, object))) – The value to assign to the security_attributes property of this LaunchInstanceDetails.
display_name (str) – The value to assign to the display_name property of this LaunchInstanceDetails.
extended_metadata (dict(str, object)) – The value to assign to the extended_metadata property of this LaunchInstanceDetails.
fault_domain (str) – The value to assign to the fault_domain property of this LaunchInstanceDetails.
cluster_placement_group_id (str) – The value to assign to the cluster_placement_group_id property of this LaunchInstanceDetails.
freeform_tags (dict(str, str)) – The value to assign to the freeform_tags property of this LaunchInstanceDetails.
compute_cluster_id (str) – The value to assign to the compute_cluster_id property of this LaunchInstanceDetails.
hostname_label (str) – The value to assign to the hostname_label property of this LaunchInstanceDetails.
image_id (str) – The value to assign to the image_id property of this LaunchInstanceDetails.
ipxe_script (str) – The value to assign to the ipxe_script property of this LaunchInstanceDetails.
launch_options (oci.core.models.LaunchOptions) – The value to assign to the launch_options property of this LaunchInstanceDetails.
instance_options (oci.core.models.InstanceOptions) – The value to assign to the instance_options property of this LaunchInstanceDetails.
availability_config (oci.core.models.LaunchInstanceAvailabilityConfigDetails) – The value to assign to the availability_config property of this LaunchInstanceDetails.
preemptible_instance_config (oci.core.models.PreemptibleInstanceConfigDetails) – The value to assign to the preemptible_instance_config property of this LaunchInstanceDetails.
metadata (dict(str, str)) – The value to assign to the metadata property of this LaunchInstanceDetails.
agent_config (oci.core.models.LaunchInstanceAgentConfigDetails) – The value to assign to the agent_config property of this LaunchInstanceDetails.
shape (str) – The value to assign to the shape property of this LaunchInstanceDetails.
shape_config (oci.core.models.LaunchInstanceShapeConfigDetails) – The value to assign to the shape_config property of this LaunchInstanceDetails.
source_details (oci.core.models.InstanceSourceDetails) – The value to assign to the source_details property of this LaunchInstanceDetails.
subnet_id (str) – The value to assign to the subnet_id property of this LaunchInstanceDetails.
launch_volume_attachments (list[oci.core.models.LaunchAttachVolumeDetails]) – The value to assign to the launch_volume_attachments property of this LaunchInstanceDetails.
is_pv_encryption_in_transit_enabled (bool) – The value to assign to the is_pv_encryption_in_transit_enabled property of this LaunchInstanceDetails.
platform_config (oci.core.models.LaunchInstancePlatformConfig) – The value to assign to the platform_config property of this LaunchInstanceDetails.
placement_constraint_details (oci.core.models.PlacementConstraintDetails) – The value to assign to the placement_constraint_details property of this LaunchInstanceDetails.
is_ai_enterprise_enabled (bool) – The value to assign to the is_ai_enterprise_enabled property of this LaunchInstanceDetails.
instance_configuration_id (str) – The value to assign to the instance_configuration_id property of this LaunchInstanceDetails.
licensing_configs (list[oci.core.models.LaunchInstanceLicensingConfig]) – The value to assign to the licensing_configs property of this LaunchInstanceDetails.
- property agent_config¶
Gets the agent_config of this LaunchInstanceDetails.
- Returns
The agent_config of this LaunchInstanceDetails.
- Return type
- property availability_config¶
Gets the availability_config of this LaunchInstanceDetails.
- Returns
The availability_config of this LaunchInstanceDetails.
- Return type
- property availability_domain¶
[Required] Gets the availability_domain of this LaunchInstanceDetails. The availability domain of the instance.
Example: Uocm:PHX-AD-1
- Returns
The availability_domain of this LaunchInstanceDetails.
- Return type
str
- property capacity_reservation_id¶
Gets the capacity_reservation_id of this LaunchInstanceDetails. The OCID of the compute capacity reservation this instance is launched under. You can opt out of all default reservations by specifying an empty string as input for this field. For more information, see Capacity Reservations.
- Returns
The capacity_reservation_id of this LaunchInstanceDetails.
- Return type
str
- property cluster_placement_group_id¶
Gets the cluster_placement_group_id of this LaunchInstanceDetails. The OCID of the cluster placement group of the instance.
- Returns
The cluster_placement_group_id of this LaunchInstanceDetails.
- Return type
str
- property compartment_id¶
[Required] Gets the compartment_id of this LaunchInstanceDetails. The OCID of the compartment.
- Returns
The compartment_id of this LaunchInstanceDetails.
- Return type
str
- property compute_cluster_id¶
Gets the compute_cluster_id of this LaunchInstanceDetails. The OCID of the compute cluster that the instance will be created in.
- Returns
The compute_cluster_id of this LaunchInstanceDetails.
- Return type
str
- property create_vnic_details¶
Gets the create_vnic_details of this LaunchInstanceDetails.
- Returns
The create_vnic_details of this LaunchInstanceDetails.
- Return type
- property dedicated_vm_host_id¶
Gets the dedicated_vm_host_id of this LaunchInstanceDetails. The OCID of the dedicated virtual machine host to place the instance on.
- Returns
The dedicated_vm_host_id of this LaunchInstanceDetails.
- Return type
str
- property defined_tags¶
Gets the defined_tags of this LaunchInstanceDetails. Defined tags for this resource. Each key is predefined and scoped to a namespace. For more information, see Resource Tags.
Example: {“Operations”: {“CostCenter”: “42”}}
- Returns
The defined_tags of this LaunchInstanceDetails.
- Return type
dict(str, dict(str, object))
- property display_name¶
Gets the display_name of this LaunchInstanceDetails. A user-friendly name. Does not have to be unique, and it’s changeable. Avoid entering confidential information.
- Returns
The display_name of this LaunchInstanceDetails.
- Return type
str
- property extended_metadata¶
Gets the extended_metadata of this LaunchInstanceDetails. Additional metadata key/value pairs that you provide. They serve the same purpose and functionality as fields in the metadata object.
They are distinguished from metadata fields in that these can be nested JSON objects (whereas metadata fields are string/string maps only).
The combined size of the metadata and extendedMetadata objects can be a maximum of 32,000 bytes.
- Returns
The extended_metadata of this LaunchInstanceDetails.
- Return type
dict(str, object)
- property fault_domain¶
Gets the fault_domain of this LaunchInstanceDetails. A fault domain is a grouping of hardware and infrastructure within an availability domain. Each availability domain contains three fault domains. Fault domains let you distribute your instances so that they are not on the same physical hardware within a single availability domain. A hardware failure or Compute hardware maintenance that affects one fault domain does not affect instances in other fault domains.
If you do not specify the fault domain, the system selects one for you.
To get a list of fault domains, use the
list_fault_domains()operation in the Identity and Access Management Service API.Example: FAULT-DOMAIN-1
- Returns
The fault_domain of this LaunchInstanceDetails.
- Return type
str
- property freeform_tags¶
Gets the freeform_tags of this LaunchInstanceDetails. Free-form tags for this resource. Each tag is a simple key-value pair with no predefined name, type, or namespace. For more information, see Resource Tags.
Example: {“Department”: “Finance”}
- Returns
The freeform_tags of this LaunchInstanceDetails.
- Return type
dict(str, str)
- property hostname_label¶
Gets the hostname_label of this LaunchInstanceDetails. Deprecated. Instead use hostnameLabel in
CreateVnicDetails. If you provide both, the values must match.- Returns
The hostname_label of this LaunchInstanceDetails.
- Return type
str
- property image_id¶
Gets the image_id of this LaunchInstanceDetails. Deprecated. Use sourceDetails with
instance_source_via_image_details()source type instead. If you specify values for both, the values must match.- Returns
The image_id of this LaunchInstanceDetails.
- Return type
str
- property instance_configuration_id¶
Gets the instance_configuration_id of this LaunchInstanceDetails. The OCID of the Instance Configuration containing instance launch details. Any other fields supplied in this instance launch request will override the details stored in the Instance Configuration for this instance launch.
- Returns
The instance_configuration_id of this LaunchInstanceDetails.
- Return type
str
- property instance_options¶
Gets the instance_options of this LaunchInstanceDetails.
- Returns
The instance_options of this LaunchInstanceDetails.
- Return type
- property ipxe_script¶
Gets the ipxe_script of this LaunchInstanceDetails. This is an advanced option.
When a bare metal or virtual machine instance boots, the iPXE firmware that runs on the instance is configured to run an iPXE script to continue the boot process.
If you want more control over the boot process, you can provide your own custom iPXE script that will run when the instance boots. Be aware that the same iPXE script will run every time an instance boots, not only after the initial LaunchInstance call.
The default iPXE script connects to the instance’s local boot volume over iSCSI and performs a network boot. If you use a custom iPXE script and want to network-boot from the instance’s local boot volume over iSCSI the same way as the default iPXE script, use the following iSCSI IP address: 169.254.0.2, and boot volume IQN: iqn.2015-02.oracle.boot.
If your instance boot volume attachment type is paravirtualized, the boot volume is attached to the instance through virtio-scsi and no iPXE script is used. If your instance boot volume attachment type is paravirtualized and you use custom iPXE to network boot into your instance, the primary boot volume is attached as a data volume through virtio-scsi drive.
For more information about the Bring Your Own Image feature of Oracle Cloud Infrastructure, see Bring Your Own Image.
For more information about iPXE, see http://ipxe.org.
- Returns
The ipxe_script of this LaunchInstanceDetails.
- Return type
str
- property is_ai_enterprise_enabled¶
Gets the is_ai_enterprise_enabled of this LaunchInstanceDetails. Whether to enable AI enterprise on the instance.
- Returns
The is_ai_enterprise_enabled of this LaunchInstanceDetails.
- Return type
bool
- property is_pv_encryption_in_transit_enabled¶
Gets the is_pv_encryption_in_transit_enabled of this LaunchInstanceDetails. Whether to enable in-transit encryption for the data volume’s paravirtualized attachment. This field applies to both block volumes and boot volumes. The default value is false.
- Returns
The is_pv_encryption_in_transit_enabled of this LaunchInstanceDetails.
- Return type
bool
- property launch_options¶
Gets the launch_options of this LaunchInstanceDetails.
- Returns
The launch_options of this LaunchInstanceDetails.
- Return type
- property launch_volume_attachments¶
Gets the launch_volume_attachments of this LaunchInstanceDetails. Volume attachments to create as part of the launch instance operation.
- Returns
The launch_volume_attachments of this LaunchInstanceDetails.
- Return type
- property licensing_configs¶
Gets the licensing_configs of this LaunchInstanceDetails. List of licensing configurations associated with target launch values.
- Returns
The licensing_configs of this LaunchInstanceDetails.
- Return type
- property metadata¶
Gets the metadata of this LaunchInstanceDetails. Custom metadata key/value pairs that you provide, such as the SSH public key required to connect to the instance.
A metadata service runs on every launched instance. The service is an HTTP endpoint listening on 169.254.169.254. You can use the service to:
Provide information to Cloud-Init to be used for various system initialization tasks.
Get information about the instance, including the custom metadata that you provide when you launch the instance.
Providing Cloud-Init Metadata
You can use the following metadata key names to provide information to Cloud-Init:
“ssh_authorized_keys” - Provide one or more public SSH keys to be included in the ~/.ssh/authorized_keys file for the default user on the instance. Use a newline character to separate multiple keys. The SSH keys must be in the format necessary for the authorized_keys file, as shown in the example below.
“user_data” - Provide your own base64-encoded data to be used by Cloud-Init to run custom scripts or provide custom Cloud-Init configuration. For information about how to take advantage of user data, see the Cloud-Init Documentation.
Metadata Example
- “metadata”{
“quake_bot_level” : “Severe”, “ssh_authorized_keys” : “ssh-rsa <your_public_SSH_key>== rsa-key-20160227”, “user_data” : “<your_public_SSH_key>==”
}
Getting Metadata on the Instance
To get information about your instance, connect to the instance using SSH and issue any of the following GET requests:
curl -H “Authorization: Bearer Oracle” http://169.254.169.254/opc/v2/instance/ curl -H “Authorization: Bearer Oracle” http://169.254.169.254/opc/v2/instance/metadata/ curl -H “Authorization: Bearer Oracle” http://169.254.169.254/opc/v2/instance/metadata/<any-key-name>
You’ll get back a response that includes all the instance information; only the metadata information; or the metadata information for the specified key name, respectively.
The combined size of the metadata and extendedMetadata objects can be a maximum of 32,000 bytes.
- Returns
The metadata of this LaunchInstanceDetails.
- Return type
dict(str, str)
- property placement_constraint_details¶
Gets the placement_constraint_details of this LaunchInstanceDetails.
- Returns
The placement_constraint_details of this LaunchInstanceDetails.
- Return type
- property platform_config¶
Gets the platform_config of this LaunchInstanceDetails.
- Returns
The platform_config of this LaunchInstanceDetails.
- Return type
- property preemptible_instance_config¶
Gets the preemptible_instance_config of this LaunchInstanceDetails.
- Returns
The preemptible_instance_config of this LaunchInstanceDetails.
- Return type
- property security_attributes¶
Gets the security_attributes of this LaunchInstanceDetails. Security attributes are labels for a resource that can be referenced in a Zero Trust Packet Routing (ZPR) policy to control access to ZPR-supported resources.
Example: {“Oracle-DataSecurity-ZPR”: {“MaxEgressCount”: {“value”:”42”,”mode”:”audit”}}}
- Returns
The security_attributes of this LaunchInstanceDetails.
- Return type
dict(str, dict(str, object))
- property shape¶
Gets the shape of this LaunchInstanceDetails. The shape of an instance. The shape determines the number of CPUs, amount of memory, and other resources allocated to the instance.
You can enumerate all available shapes by calling
list_shapes().- Returns
The shape of this LaunchInstanceDetails.
- Return type
str
- property shape_config¶
Gets the shape_config of this LaunchInstanceDetails.
- Returns
The shape_config of this LaunchInstanceDetails.
- Return type
- property source_details¶
Gets the source_details of this LaunchInstanceDetails.
- Returns
The source_details of this LaunchInstanceDetails.
- Return type
- property subnet_id¶
Gets the subnet_id of this LaunchInstanceDetails. Deprecated. Instead use subnetId in
CreateVnicDetails. At least one of them is required; if you provide both, the values must match.- Returns
The subnet_id of this LaunchInstanceDetails.
- Return type
str